###
# omg-helperfunctions
#
# Copyright (c) 2015 Ferrari electronic AG
###
# coffeelint: disable=max_line_length

'use strict'
_ = require('lodash')
exec = require('child_process').exec
module.exports =
  convertZmqResponse: (response) ->
    producer = undefined
    response = String(response)
    response = response.split(' ')
    producer = response[0]
    response.shift()
    response = response.join(' ')
    [
      producer
      response
    ]
  zmqPureMessage: (res) ->
    res = module.exports.convertZmqResponse(res)[1]
    try
      res = JSON.parse(res)
    catch
      console.log 'Helperfunction could not parse JSON:' + JSON.stringify(res)
    res
  replaceAll: (find, replace, str) ->
    str.replace new RegExp(find, 'g'), replace
  stdout2array: (cmd, callback) ->
    exec cmd, (error, stdout, stderr) ->
      lines = stdout.split('\n')
      if lines[lines.length - 1] == ''
        lines.pop()
      #cut last empty line!
      callback error or stderr, lines
    return
  array2object: (arr, propName, callback) ->
    obj = {}
    if propName == undefined
      _.each arr, (val, key) ->
        obj[key] = val
        return
    else
      _.each arr, (val) ->
        obj[val[propName]] = val
        return
    callback null, obj
  setObjPath: (obj, path, value) ->
    parts = path.split('.')
    part = undefined

    error = (txt) ->
      throw new TypeError(txt)
      return

    while part = parts.shift()
      if parts.length
        obj = if part of obj and obj[part] instanceof Object then obj[part] else if part of obj then error('key [' + part + '] exists but is not an object') else obj[part] = {}
        obj[part]
      else
        obj[part] = value
    return
  replaceByString: (obj, path, data, callback) ->
    if data == undefined
      return @deleteByString(obj, path, callback)
    if typeof data == 'string'
      try
        data = JSON.parse(data)
      catch
    if _.isEqual(@getPropByString(obj, path), data) == false
      sp = path.split('.')
      node = sp.pop()
      parent = sp.join('.')
      update = {}
      #create empty object
      @setObjPath update, path, data
      #create path {dynamic.uptime}, set value
      if parent != ''
        if @getPropByString(obj, parent) != undefined and @getPropByString(obj, parent)[node] != undefined
          #console.log("obj existed, letz replace");
          @getPropByString(obj, parent)[node] = data
        else
          #console.log("no such obj yet..creating")
          _.merge obj, update
      else
        obj[node] = data
      if callback
        return callback(null, true)
      true
    else
      if callback
        return callback(null, false)
      false
  deleteByString: (obj, path, callback) ->
    if path.indexOf('.') == -1
      #no dot in path
      if obj[path] != undefined
        delete obj[path]
        if callback
          return callback(null, true)
        return true
    else
      sp = path.split('.')
      node = sp.pop()
      parent = sp.join('.')
      if @getPropByString(obj, parent) != undefined and @getPropByString(obj, parent)[node] != undefined
        delete @getPropByString(obj, parent)[node]
        if callback
          return callback(null, true)
        return true
      else
        #logger.info("deleteByString, obj not deleted, not found: " + path)
    if callback
      return callback(null, false)
    false
  getPropByString: (obj, propString) ->
    if obj == null
      throw new Error(' OBJECT IS NULL')
    if !propString
      throw new Error('EMPTY String PATH REQUEST')
    str = propString
    isTrue = true
    prop = undefined
    props = []
    while isTrue
      stop = undefined
      start = str.match(/^\[/)
      if start != null
        stop = str.match(/\]/)
        props.push str.substring(start.index + 1, stop.index)
        str = str.substring(stop.index + 1)
      else
        isTrue = str.match(/\./)
        if isTrue == null
          if str.length
            props.push str
          break
        props.push str.substring(0, isTrue.index)
        str = str.substring(isTrue.index + 1)
    if !props.length
      props[0] = propString
    if obj == null
      throw new Error(' OBJECT IS NULL')
    k = 0
    iLen = props.length - 1
    while k < iLen
      k++
    if obj == null
      throw new Error(' OBJECT IS FINALLY NULL')
    l = 0
    lLen = props.length - 1
    while l < lLen
      prop = props[l]
      try
        test = undefined
        test = obj[prop]
      catch
        console.log '======================='
        console.log _.keys(obj).length
        throw new Error(' NO SUCH KEY: ' + prop)
      candidate = obj[prop]
      if candidate != undefined and candidate != null
        obj = candidate
      else
        break
      l++
    try
      return obj[props[l]]
    catch
      console.log 'node didnt exist'
      return {}
    return
  isEmpty: (obj) ->
    for prop of obj
      if obj.hasOwnProperty(prop)
        return false
    true
